<?php

namespace tpScriptVueCurd\enum;


enum Ev
{
    /**
     * 设置列表数据展示时事件（单行）
     * function(ModelField $field){ }
     */
    case IndexRow;

    /**
     * 设置列表数据展示时事件（列表）
     * function(ModelField $field,Collection $list){ }
     */
    case IndexList;

    /**
     * 设置列表数据展示时事件（单行）
     * function(ModelField $field,array &$row){ }
     */
    case IndexRowAfter;

    /**
     * 设置列表数据展示时事件（列表，所有数据都处理完成后）
     * function(ModelField $field,array &$list){ }
     */
    case IndexListAfter;


    /**
     * 设置列表页面显示时事件
     * function(ModelField $field){ }
     */
    case IndexShow;

    /**
     * 设置字段列表筛选时事件
     * function(ModelField $field,Query $query,array &$filterData){}
     */
    case IndexFilterBefore;


    /**
     * 设置详情页字段事件
     * function(ModelField $field){ }
     */
    case ShowInfoBefore;


    /**
     * 设置详情页字段事件
     * function(ModelField $field){ }
     */
    case ShowInfo;

    /**
     * 设置详情页字段事件
     * function(ModelField $field,array &$info){ }
     */
    case ShowInfoAfter;


    /**
     * 设置数据编辑显示字段事件
     * function(ModelField $field,bool $isStepNext){ }
     */
    case EditShow;

    /**
     * 提交的数据验证前
     * function(ModelField $field){ }
     */
    case SaveDataCheckBefore;

    /**
     * 设置数据保存前字段事件
     * function(ModelField $field){ }
     */
    case SaveBefore;


    /**
     * 设置数据保存后字段事件
     * function(ModelField $field){ }
     */
    case SaveAfter;


    /**
     * 设置数据导出事件（列表，数据处理之前）
     * function(ModelField $field,array &$list){ }
     */
    case ExportListBefore;

    /**
     * 设置数据导出事件
     * function(ModelField $field,array &$info){ }
     */
    case ExportBefore;


    /**
     * 设置数据导出事件
     * function(ModelField $field,array &$data,array $info){ }
     */
    case ExportAfter;

    public function name():string{
        return $this->name;
    }
}
