<?php

namespace tpScriptVueCurd\field;

use tpScriptVueCurd\ExcelFieldTpl;
use tpScriptVueCurd\filter\EmptyFilter;
use tpScriptVueCurd\ModelField;
use tpScriptVueCurd\option\generate_table\GenerateColumnOption;
use tpScriptVueCurd\tool\field_tpl\FieldTpl;

class ColorField extends ModelField
{
    protected string $defaultFilterClass=EmptyFilter::class;
    protected string|int|float $nullVal='';//字段在数据库中为空时的值


    public function excelTplExplain(ExcelFieldTpl $excelFieldTpl): void
    {
        $excelFieldTpl->explain='请输入HEX颜色代码';
    }

    public static function componentUrl(): FieldTpl
    {
        return FieldTpl::make(static::class,'/tpscriptvuecurd/field/color');
    }

    public function getGenerateColumnConfig(GenerateColumnOption $option): void
    {
        $option->setTypeVarchar(9);
    }
}