<?php


namespace tpScriptVueCurd\field;


use think\route\Url;
use tpScriptVueCurd\ExcelFieldTpl;
use tpScriptVueCurd\filter\EmptyFilter;
use tpScriptVueCurd\ModelField;
use tpScriptVueCurd\option\generate_table\GenerateColumnOption;
use tpScriptVueCurd\tool\field_tpl\FieldTpl;

class IframeField extends ModelField
{

    protected string $defaultFilterClass = EmptyFilter::class;

//    protected bool $showInDetails = false;
    protected bool $canExcelImport = false;

    protected string $topHrText='';
    protected string $bottomHrText='';

    protected string $url='';

    protected $generateColumn=false;

    public function __construct()
    {
        parent::__construct();
        $this->editWrapperCol(['span'=>24]);
    }

    /**
     * 模板导入时备注
     * @param ExcelFieldTpl $excelFieldTpl
     * @return void
     */
    public function excelTplExplain(ExcelFieldTpl $excelFieldTpl): void
    {
        $excelFieldTpl->explain = '不可导入';
    }

    /**
     * 字段模板配置
     * @return FieldTpl
     */
    public static function componentUrl(): FieldTpl
    {
        return new FieldTpl(static::class,
            show:'/tpscriptvuecurd/field/iframe/show.js',
            edit:'/tpscriptvuecurd/field/iframe/edit.js'
        );
    }

    /**
     * @param string|Url|null $url
     * @return $this|string
     */
    public function url(string|Url $url=null): string|static
    {
        if($url instanceof Url){
            $url=$url->build();
        }
        return $this->doAttr('url',$url);
    }

    public function setCanExcelImport(bool $canExcelImport): void
    {
        if ($canExcelImport === true) {
            throw new \think\Exception('字段不可设置为导入');
        }
        $this->canExcelImport = $canExcelImport;
    }


    public function showInList(bool $showInList = null): bool|static
    {
        if ($showInList === true) {
            throw new \think\Exception('字段不可设置showInList为true');
        }
        return parent::showInList($showInList);
    }

    public function topHrText(string $topHrText=null):string|static{
        return $this->doAttr('topHrText',$topHrText);
    }

    public function bottomHrText(string $bottomHrText=null):string|static{
        return $this->doAttr('bottomHrText',$bottomHrText);
    }

    public function getGenerateColumnConfig(GenerateColumnOption $option): void
    {
        $option->setTypeVarchar();
    }

    public function toArray(): array
    {
        if($this->title===''){
            $this->showUseComponent(true);
        }
        return parent::toArray();
    }
}