<?php


namespace tpScriptVueCurd\option;


use think\Collection;
use think\db\Query;
use tpScriptVueCurd\base\model\BaseModel;
use tpScriptVueCurd\enum\Ev;
use tpScriptVueCurd\FieldCollection;
use tpScriptVueCurd\ModelField;

class FieldDo
{
    /**
     * 事件集合
     * @var callable[]
     */
    private array $eventArr=[];
    public function __construct(private ModelField $field)
    {
    }



    private function doFunc(Ev $type, mixed &$other=null, mixed &$other2=null): void
    {
        $typeName=$type->name();
        if(!isset($this->eventArr[$typeName])){
            return;
        }
        foreach ($this->eventArr[$typeName] as $fn){
            $fn($this->field,$other,$other2);
        }
    }

    /**
     * 触发事件
     * @param Ev $type
     * @param FieldCollection $fields
     * @param mixed|null $other
     * @param mixed|null $other2
     * @return void
     */
    public static function doFuncByFields(Ev $type, FieldCollection $fields, mixed &$other=null, mixed &$other2=null):void{
        $fields->each(function(ModelField $field)use($type,&$other,&$other2){
            $field->getFieldEvent()?->doFunc($type,$other,$other2);
        });
    }


    public function on(Ev $type, callable $fn):self{
        isset($this->eventArr[$type->name()])||$this->eventArr[$type->name()]=[];
        $this->eventArr[$type->name()][]=$fn;
        return $this;
    }
}