<?php


namespace tpScriptVueCurd\tool\field_tpl;


class FieldTpl
{

    public string $name;

    public Index $index;

    public Show $show;

    public Edit $edit;

    public function __construct(string $fieldType,null|string|Index $index=null,null|string|Show $show=null,null|string|Edit $edit=null)
    {
        $fieldType=class_basename($fieldType);
        if(is_null($index)){
            $index=new Index('');
        }else if(is_string($index)){
            $index=new Index($index);
        }
        $index->name||$index->setName($fieldType);

        if(is_null($show)){
            $show=new Show('');
        }else if(is_string($show)){
            $show=new Show($show);
        }
        $show->name||$show->setName($fieldType);

        if(is_null($edit)){
            $edit=new Edit('');
        }else if(is_string($edit)){
            $edit=new Edit($edit);
        }
        $edit->name||$edit->setName($fieldType);

        $this->name=$fieldType;
        $this->index=$index;
        $this->show=$show;
        $this->edit=$edit;
    }

    public static function make(string $fieldType,string $dir):self{
        $dir=rtrim($dir,'/').'/';
        return new self($fieldType,$dir.'index.js',$dir.'show.js',$dir.'edit.js');
    }

    public function toArray($obj=null){
        return $this->objectToArray(is_null($obj)?$this:$obj);
    }

    private function objectToArray($array) {
        if(is_array($array)){
            $arr=$array;
        }else if(is_object($array)) {
            $arr = get_object_vars($array);
        }else{
            return $array;
        }
        foreach($arr as $key=>$value) {
            $arr[$key] = $this->objectToArray($value);
        }
        return $arr;
    }
}