<?php

namespace tpScriptVueCurd\traits\controller;

use think\Exception;
use think\model\Collection;
use think\response\Json;
use tpScriptVueCurd\annotate\AuthTitle;
use tpScriptVueCurd\base\controller\Controller;
use tpScriptVueCurd\base\model\BaseModel;
use tpScriptVueCurd\enum\ErrorCode;
use tpScriptVueCurd\traits\controller\module\DelModule;

/**
 * @property BaseModel $md
 */
trait BaseDel
{
    use DelModule;
    #[AuthTitle('删除数据')]
    public function del(){
        $ids=$this->request->param('ids/a',[]);
        $ids=array_filter($ids);
        if(empty($ids)){
            $this->errorOut('请选择要删除的数据');
        }
        $this->md->startTrans();
        $list=$this->md->whereIn('id',$ids)->select();

        try{
            $list=$this->delBefore($list);
            $this->delChilds($list);
            $this->doDelect(clone $this->md,$ids);
        }catch (\Exception $e){
            $this->md->rollback();
            $this->errorOut($e);
        }

        $this->md->commit();
        $this->successOut('删除成功');
    }


    /**
     * 递归删除子表数据
     */
    protected function delChilds(Collection $list):void{
        $childControllers=$this->getChildControllers();
        if($childControllers&&$this->request->param('delChilds/d')===1) {
            $parents=[];
            foreach ($list as $v){
                $parents[$v['id']]=$v;
            }
            $pids = array_keys($parents);
            foreach ($childControllers as $childController) {
                /**
                 * @var Controller $childController
                 */
                $modelClass=$childController->md::class;
                $parentField =$modelClass::parentField();
                $childList=[];
                foreach ($modelClass::whereIn($parentField,$pids)->select() as $val){
                    isset($childList[$val[$parentField]])||$childList[$val[$parentField]]=[];

                    $childList[$val[$parentField]][]=$val;
                }

                foreach ($childList as $key=>$val){
                    $val=$childController->md->toCollection($val);
                    $childController->setInfo(clone $childController->md);
                    $childController->getInfo()->setParentInfo($parents[$key]);
                    foreach ($val as $v){
                        $v->setParentInfo($parents[$key]);
                    }
                    $val=$childController->delBefore($val);
                    $childController->delChilds($val);
                    $childController->doDelect($val);
                }
            }
        }
    }

    /**
     * 删除时
     * @param Collection $list
     * @throws Exception
     */
    protected function doDelect(Collection $list){
        if($this->treePidField){
            $childId=$this->md->whereIn($this->treePidField,$list->column('id'))->value('id');
            if($childId){
                throw new Exception('请先删除下级数据',ErrorCode::DeleteTreeHaveChild->value());
            }
        }
        $list= $this->md->del($list);
        $this->delAfter($list);
    }
}