<?php

namespace tpScriptVueCurd\traits\controller;

use tpScriptVueCurd\annotate\AuthTitle;
use tpScriptVueCurd\ModelField;
use tpScriptVueCurd\option\FieldStep;

/**
 * 流程图相关
 */
trait Bpmn
{


    #[AuthTitle('显示流程图',100)]
    public function bpmn(){
        if(!$this->steps){
            $this->errorOut('未启用步骤');
        }

        $data=[
            // 点集
            'nodes'=>[],
            // 边集
            'edges'=>[],
        ];

        $steps=[];
        $allSteps=[];
        $stepAlias=[];
        foreach ($this->steps as $step){
            $stepName=$step::name();
            $allSteps[$stepName]=$step;
            $befores=[];
            $stepHave=null;
            foreach ($step->getBeforeSteps() as $key=>$val){
                $beforeName=$key?$key::name():'';
                $beforeInfo=[
                    'remark'=>$val->remark,
                    'name'=>$beforeName,
                ];

                if($val->title){
                    $stepHave===null&&$stepHave=false;
                    $sn=$stepName.'-'.$val->title;
                    if(!isset($steps[$sn])){
                        $steps[$sn]=[
                            'title'=>$val->title,
                            'name'=>$sn,
                            'source_name'=>$stepName,
                            'befores'=>[],
                        ];
                        isset($stepAlias[$stepName])||$stepAlias[$stepName]=[];
                        $stepAlias[$stepName][]=$sn;
                    }
                    $steps[$sn]['befores'][$beforeName]=$beforeInfo;
                }else{
                    $stepHave=true;
                    $befores[$beforeName]=$beforeInfo;
                }

                if($stepHave||$stepHave===null){
                    $steps[$stepName]=[
                        'title'=>$step->getTitle(),
                        'name'=>$stepName,
                        'befores'=>$befores,
                    ];
                }
            }
        }


        $nextSteps=[];
        foreach ($steps as $k=>$v){
            foreach ($v['befores'] as $key=>$val){
                isset($nextSteps[$key])||$nextSteps[$key]=[];
                $nextSteps[$key][]=$k;
                if(!empty($stepAlias[$key])){
                    foreach ($stepAlias[$key] as $vv){
                        $nextSteps[$vv][]=$k;
                    }
                }
            }
        }

        foreach ($steps as $k=>$v){
            $isFirst=false;
            foreach ($v['befores'] as $key=>$val){
                if($key===''){
                    $isFirst=true;
                    continue;
                }

                if($key!==$k){
                    $data['edges'][]=['source'=>$key,'target'=>$k,'label'=>$val['remark']];
                    if(!empty($stepAlias[$key])){
                        foreach ($stepAlias[$key] as $vv){
                            $data['edges'][]=['source'=>$vv,'target'=>$k,'label'=>$val['remark']];
                        }
                    }
                }
            }
            $node=['id'=>$k,'label'=>$v['title'],'type'=>$isFirst||empty($nextSteps[$k])?'rect':'ellipse'];
            if($node['type']==='rect'){
                $node['style']['radius']=2;
            }
            $data['nodes'][]=$node;
        }

        return $this->fetch(getVCurdDir().'tpl/step/bpmn.vue',[
            'data'=>$data,
            'jsPath'=>'/tpscriptvuecurd/actions/step.js',
        ]);
    }
}