<?php

namespace tpScriptVueCurd\traits\controller\module;

use think\db\Query;
use tpScriptVueCurd\base\model\BaseModel;
use tpScriptVueCurd\FieldCollection;
use tpScriptVueCurd\option\index_row_btn\OpenBtn;
use tpScriptVueCurd\option\index_row_btn\RowBtn;
use tpScriptVueCurd\option\LeftCate;
use tpScriptVueCurd\option\parameters\FunControllerIndexData;
use tpScriptVueCurd\option\parameters\FunControllerIndexPage;

trait IndexModule
{

    public FunControllerIndexPage $indexPageOption;

    /**
     * 列表分页设置
     * @return void
     */
    protected function setIndexPageOption():void{
        //$this->indexPageOption
    }


    /**
     * 列表自定义条件
     * @param Query $query
     */
    protected function indexListWhere(Query $query):void{

    }


    protected function indexShowBefore():void{
        //要改fields，可以直接在 这里 $this->fields
        // 列表页面显示前处理，在indexFetch前
    }



    /**
     * @param FieldCollection $filterFields 筛选相关字段
     * @param array|null $filterData    筛选默认值
     * @param bool $showFilter  是否显示筛选
     * @return void
     */
    protected function indexFilterBefore(FieldCollection $filterFields, ?array &$filterData, bool &$showFilter):void{
        //index筛选显示前
    }


    /**
     * 设置左侧分组显示
     * @return LeftCate|null
     */
    public function getLeftCate(): ?LeftCate{return null;}




    /**
     * 列表按钮组左侧
     * @param BaseModel $info               当前行信息
     * @param FieldCollection $fields
     * @param BaseModel|null $parentInfo
     * @param \think\model\Collection $list 列表信息
     * @return RowBtn[]|OpenBtn[]
     */
    public function getListRowBeforeBtns(\think\model\Collection $list): array
    {
        return [];
    }

    /**
     * 列表按钮组右侧
     * @param BaseModel $info               当前行信息
     * @param FieldCollection $fields
     * @param BaseModel|null $parentInfo
     * @param \think\model\Collection $list 列表信息
     * @return RowBtn[]|OpenBtn[]
     */
    public function getListRowAfterBtns(\think\model\Collection $list): array
    {
        return [];
    }

    /**
     * 工具栏标题左侧按钮
     * @param FieldCollection $fields       当前字段信息
     * @param BaseModel|null $parentInfo    父表
     * @return RowBtn[]|OpenBtn[]
     */
    public function getToolTitleLeftBtns():array{
        return [];
    }


    /**
     * 工具栏标题右侧按钮
     * @param FieldCollection $fields       当前字段信息
     * @param BaseModel|null $parentInfo    父表
     * @return RowBtn[]|OpenBtn[]
     */
    public function getToolTitleRightBtns():array{
        return [];
    }


    /**
     * 工具栏右侧按钮集左边
     * @param FieldCollection $fields       当前字段信息
     * @param BaseModel|null $parentInfo    父表
     * @return RowBtn[]|OpenBtn[]
     */
    public function getToolBtnLeftBtns():array{
        return [];
    }


    /**
     * 工具栏右侧按钮集右边
     * @param FieldCollection $fields       当前字段信息
     * @param BaseModel|null $parentInfo    父表
     * @return RowBtn[]|OpenBtn[]
     */
    public function getToolBtnRightBtns():array{
        return [];
    }



    protected function indexFetch(array &$fetch):void{
        // 列表页面显示前处理，在indexShowBefore后
    }


    protected function indexData(FunControllerIndexData $option):void{
        //列表数据处理钩子
    }
}