<?php

namespace tpScriptVueCurd\traits\model;

use think\facade\Event;
use tpScriptVueCurd\base\model\VueCurlModel;
use tpScriptVueCurd\FieldCollection;
use tpScriptVueCurd\option\step\StepCollection;

trait ModelConfig
{
    protected   FieldCollection|StepCollection $fields;

    /**
     * @var FieldCollection[]|StepCollection=[]
     */
    protected array $filedCollectionList=[];

    abstract protected function fields():FieldCollection|StepCollection;

    /**
     * 获取所有的字段配置
     * @return FieldCollection
     */
    public function getFieldConfig():FieldCollection{
        $fields=$this->getInitConfig();
        if($fields instanceof FieldCollection){
            return $fields;
        }
        $fieldList=[];
        foreach ($fields as $v){
            array_push($fieldList,...$v);
        }
        $fields=FieldCollection::make($fieldList);
        $this->setConfigInfo($fields);
        return  $fields;
    }


    /**
     * 获取步骤配置
     * @return StepCollection|null
     */
    public function getStepConfig():?StepCollection{
        $fields=$this->getInitConfig();
        if($fields instanceof FieldCollection){
            return null;
        }
        return $fields;
    }



    protected function getInitConfig(bool $update=false):FieldCollection|StepCollection{
        if($update||!isset($this->fields)){
            $key=(isset($this->controller)&&$this->controller?get_class($this->controller):'').'-'.static::class;
            if(!isset($this->filedCollectionList[$key])){
                $this->filedCollectionList[$key]=$this->fields();
            }
            $fields=clone $this->filedCollectionList[$key];
            $this->setConfigInfo($fields);
            $this->fields=$fields;
        }
        return $this->fields;
    }


    private function setConfigInfo(FieldCollection|StepCollection $fields):void{
        $fields->setInfo($this);
        $this->getInfoList()&&$fields->setInfoList($this->getInfoList());
        Event::listen('onSetInfoByController',function ($params)use($fields){
            if(isset($this->controller)&&$this->controller===$params[0]){
                $fields->setInfo($params[1]);
            }
        });
        Event::listen('onSetInfoListByController',function ($params){
            if(isset($this->controller)&&$this->controller===$params[0]){
                $this->setInfoList($params[1]);
            }
        });
    }

}