<?php


namespace tpScriptVueCurd\traits\model;


use think\db\exception\DbException;
use think\Exception;
use think\facade\Db;
use think\Model;
use think\model\Collection;
use tpScriptVueCurd\base\model\BaseModel;
use tpScriptVueCurd\enum\ActionType;

/**
 * Trait ModelDelTraits
 * @package tpScriptVueCurd\traits\model
 * @author tj 1079798840@qq.com
 */
trait ModelDelTraits
{

    /**
     * 数据删除方法
     * @param Collection|BaseModel[] $list
     * @return \think\Collection
     * @throws DbException
     * @throws Exception
     */
    final public function del(Collection $list): \think\Collection
    {
        foreach ($list as $k=>$v){
            if($v->checkRowAuth(ActionType::Del)===false){
                foreach (['title','name','realname','real_name','username','user_name','project_name','project_title'] as $val){
                    $title=$v[$val]??null;
                    if($title){
                        break;
                    }
                }
                if($title){
                    throw new \think\Exception('您不能删除数据：'.$title);
                }
                throw new \think\Exception('您不能删除第'.($k+1).'条数据，id为：'.$v['id']);

            }
        }
        $this->onDelBefore($list);

        $modelFields=[];
        $modelIds=[];
        $user=tpScriptVueCurdGetLoginData();
        foreach ($list as $result){
            /**
             * @var $result Model
             */
            //设置当前删除人
            if($user&&!empty($user['id'])){
                $class=get_class($result);
                isset($modelFields[$class])||$modelFields[$class]=$result->getFields();
                if(isset($modelFields[$class]['delete_system_admin_id'])){
                    isset($modelIds[$class])||$modelIds[$class]=[];
                    $modelIds[$class][]=$result->id;
                }
            }
            $result->delete();
        }
        foreach ($modelIds as $md=>$mdIds){
            Db::name((new $md)->getName())->whereIn('id',$mdIds)->update(['delete_system_admin_id'=>$user['id']]);
        }
        $this->onDelAfter($list);
        return $list;
    }





    protected function onDelBefore(Collection $delList): void{}//删除前钩子，子类重写
    protected function onDelAfter(Collection $delList): void{}//删除后钩子，子类重写
}